#!/usr/bin/perl

if ($#ARGV == -1)
{ die "Usage: /where/is/extractIRP.pl /path/to/myVideo.mpg\n";
}

## --------------------------------------------------
## Extract path and file name
@pathArray = split /\// , $ARGV[0];

$path = "";
foreach $i (1 .. $#pathArray-1)
{ $path = "$path/@pathArray[$i]";
}
$path = "$path/";

$nameOfVideoWithExtension = @pathArray[$#pathArray];
@nameOfFileArray = split /\./ , $nameOfVideoWithExtension;
$nameOfVideo = $nameOfFileArray[0];

## --------------------------------------------------
@execPathArray = split /\// , $0;
$execPath = "";
foreach $i (1 .. $#execPathArray-1)
{ $execPath = "$execPath/@execPathArray[$i]";
}
$execPath = "$execPath/";

## --------------------------------------------------
## create the directory for output
mkdir "$path$nameOfVideo";
chdir "$path$nameOfVideo";


## --------------------------------------------------
## run Vsoft
print "--------------------------------------------------\n";
print "--> Analysing video named <$nameOfVideoWithExtension> in <$path>\n";

$executable = join("","$execPath","Vsoft.Linux");
@commandLineArray = ("$executable" , "-IRm" , "25" , "-clippath", "$path" ,"$nameOfVideoWithExtension");
print("Running:");
print(join(" ", @commandLineArray));
print("\n");
if ((system @commandLineArray) == 0)
{ #die "ERROR in Vsoft...\n";
}

## --------------------------------------------------
## check that the file <decodeFramesList.dat> exists
open(FILE_TEST, "decodeFramesList.dat") or die "Can't open <decodeFramesList.dat>.\n"; 
close(FILE_TEST);


## --------------------------------------------------
## run ExtractIRP
print "--------------------------------------------------\n";
print "--> Extracting IRP into PPMs images\n";

$executable = join("","$execPath","ExtractIRP.Linux");
@commandLineArray = ("$executable" , "-no_display" , "-dither" , "ppm" , "../$nameOfVideoWithExtension");
system @commandLineArray;

## --------------------------------------------------
## convert PPMs to JPEGs
print "--------------------------------------------------\n";
print "--> Converting PPMs to JPEGs\n";

@images = map {glob} ('*.ppm');

if ($#images == 0)
{ die "Error in ExtractIRP.Linux...\n";
}

foreach $i (0 .. $#images) 
{
  @nameOfImageArray = split /\./ , $images[$i];
  $nameOfImage = $nameOfImageArray[0];
  @commandLineArray = ("convert" , "-sample" , "50%" , "$nameOfImage.ppm" , "$nameOfImage.jpg");
  system @commandLineArray;
  @commandLineArray = ("rm" , "-f" , "$nameOfImage.ppm");
  system @commandLineArray;

}



exit 0;
